
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>open-ViewMin &#8212; open-ViewMin  documentation</title>
    
  <!-- Loaded before other Sphinx assets -->
  <link href="_static/styles/theme.css?digest=1999514e3f237ded88cf" rel="stylesheet">
<link href="_static/styles/pydata-sphinx-theme.css?digest=1999514e3f237ded88cf" rel="stylesheet">

    
  <link rel="stylesheet"
    href="_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" href="_static/styles/sphinx-book-theme.css?digest=62ba249389abaaa9ffc34bf36a076bdc1d65ee18" type="text/css" />
    <link rel="stylesheet" type="text/css" href="_static/graphviz.css" />
    
  <!-- Pre-loaded scripts that we'll load fully later -->
  <link rel="preload" as="script" href="_static/scripts/pydata-sphinx-theme.js?digest=1999514e3f237ded88cf">

    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script src="_static/scripts/sphinx-book-theme.js?digest=f31d14ad54b65d19161ba51d4ffff3a77ae00456"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="The Filters Tree" href="filters-tree.html" />
    <link rel="prev" title="open-ViewMin documentation" href="index.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="None">
    

    <!-- Google Analytics -->
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="60">
<!-- Checkboxes to toggle the left sidebar -->
<input type="checkbox" class="sidebar-toggle" name="__navigation" id="__navigation" aria-label="Toggle navigation sidebar">
<label class="overlay overlay-navbar" for="__navigation">
    <div class="visually-hidden">Toggle navigation sidebar</div>
</label>
<!-- Checkboxes to toggle the in-page toc -->
<input type="checkbox" class="sidebar-toggle" name="__page-toc" id="__page-toc" aria-label="Toggle in-page Table of Contents">
<label class="overlay overlay-pagetoc" for="__page-toc">
    <div class="visually-hidden">Toggle in-page Table of Contents</div>
</label>
<!-- Headers at the top -->
<div class="announcement header-item noprint"></div>
<div class="header header-item noprint"></div>

    
    <div class="container-fluid" id="banner"></div>

    

    <div class="container-xl">
      <div class="row">
          
<!-- Sidebar -->
<div class="bd-sidebar noprint" id="site-navigation">
    <div class="bd-sidebar__content">
        <div class="bd-sidebar__top"><div class="navbar-brand-box">
    <a class="navbar-brand text-wrap" href="index.html">
      
      
      
      <h1 class="site-logo" id="site-title">open-ViewMin  documentation</h1>
      
    </a>
</div><form class="bd-search d-flex align-items-center" action="search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main">
    <div class="bd-toc-item active">
        <ul class="current nav bd-sidenav">
 <li class="toctree-l1 current active">
  <a class="current reference internal" href="#">
   Overview
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="filters-tree.html">
   Filters tree
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="calculations.html">
   Calculations
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="GUI-reference.html">
   GUI Reference
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="LICENSE.html">
   License
  </a>
 </li>
 <li class="toctree-l1 has-children">
  <a class="reference internal" href="api/index.html">
   API Reference
  </a>
  <input class="toctree-checkbox" id="toctree-checkbox-1" name="toctree-checkbox-1" type="checkbox"/>
  <label for="toctree-checkbox-1">
   <i class="fas fa-chevron-down">
   </i>
  </label>
  <ul>
   <li class="toctree-l2 has-children">
    <a class="reference internal" href="api/open_viewmin/index.html">
     <code class="xref py py-mod docutils literal notranslate">
      <span class="pre">
       open_viewmin
      </span>
     </code>
    </a>
    <input class="toctree-checkbox" id="toctree-checkbox-2" name="toctree-checkbox-2" type="checkbox"/>
    <label for="toctree-checkbox-2">
     <i class="fas fa-chevron-down">
     </i>
    </label>
    <ul>
     <li class="toctree-l3 has-children">
      <a class="reference internal" href="api/open_viewmin/filter_tree_plot/index.html">
       <code class="xref py py-mod docutils literal notranslate">
        <span class="pre">
         open_viewmin.filter_tree_plot
        </span>
       </code>
      </a>
      <input class="toctree-checkbox" id="toctree-checkbox-3" name="toctree-checkbox-3" type="checkbox"/>
      <label for="toctree-checkbox-3">
       <i class="fas fa-chevron-down">
       </i>
      </label>
      <ul>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/filter_tree_plot/filters/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.filter_tree_plot.filters
          </span>
         </code>
        </a>
       </li>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/filter_tree_plot/utilities/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.filter_tree_plot.utilities
          </span>
         </code>
        </a>
       </li>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/filter_tree_plot/widgets/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.filter_tree_plot.widgets
          </span>
         </code>
        </a>
       </li>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/filter_tree_plot/filter_formulas/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.filter_tree_plot.filter_formulas
          </span>
         </code>
        </a>
       </li>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/filter_tree_plot/filter_tree_plot/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.filter_tree_plot.filter_tree_plot
          </span>
         </code>
        </a>
       </li>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/filter_tree_plot/settings/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.filter_tree_plot.settings
          </span>
         </code>
        </a>
       </li>
      </ul>
     </li>
     <li class="toctree-l3 has-children">
      <a class="reference internal" href="api/open_viewmin/filter_tree_plot_Qt/index.html">
       <code class="xref py py-mod docutils literal notranslate">
        <span class="pre">
         open_viewmin.filter_tree_plot_Qt
        </span>
       </code>
      </a>
      <input class="toctree-checkbox" id="toctree-checkbox-4" name="toctree-checkbox-4" type="checkbox"/>
      <label for="toctree-checkbox-4">
       <i class="fas fa-chevron-down">
       </i>
      </label>
      <ul>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/filter_tree_plot_Qt/menus/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.filter_tree_plot_Qt.menus
          </span>
         </code>
        </a>
       </li>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/filter_tree_plot_Qt/widgets_Qt/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.filter_tree_plot_Qt.widgets_Qt
          </span>
         </code>
        </a>
       </li>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/filter_tree_plot_Qt/filter_tree_plot_Qt/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.filter_tree_plot_Qt.filter_tree_plot_Qt
          </span>
         </code>
        </a>
       </li>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/filter_tree_plot_Qt/settings_Qt/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.filter_tree_plot_Qt.settings_Qt
          </span>
         </code>
        </a>
       </li>
      </ul>
     </li>
     <li class="toctree-l3 has-children">
      <a class="reference internal" href="api/open_viewmin/nematic/index.html">
       <code class="xref py py-mod docutils literal notranslate">
        <span class="pre">
         open_viewmin.nematic
        </span>
       </code>
      </a>
      <input class="toctree-checkbox" id="toctree-checkbox-5" name="toctree-checkbox-5" type="checkbox"/>
      <label for="toctree-checkbox-5">
       <i class="fas fa-chevron-down">
       </i>
      </label>
      <ul>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/nematic/jones/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.nematic.jones
          </span>
         </code>
        </a>
       </li>
       <li class="toctree-l4">
        <a class="reference internal" href="api/open_viewmin/nematic/nematic/index.html">
         <code class="xref py py-mod docutils literal notranslate">
          <span class="pre">
           open_viewmin.nematic.nematic
          </span>
         </code>
        </a>
       </li>
      </ul>
     </li>
     <li class="toctree-l3">
      <a class="reference internal" href="api/open_viewmin/open_viewmin/index.html">
       <code class="xref py py-mod docutils literal notranslate">
        <span class="pre">
         open_viewmin.open_viewmin
        </span>
       </code>
      </a>
     </li>
    </ul>
   </li>
  </ul>
 </li>
</ul>

    </div>
</nav></div>
        <div class="bd-sidebar__bottom">
             <!-- To handle the deprecated key -->
            
            <div class="navbar_extra_footer">
            Theme by the <a href="https://ebp.jupyterbook.org">Executable Book Project</a>
            </div>
            
        </div>
    </div>
    <div id="rtd-footer-container"></div>
</div>


          


          
<!-- A tiny helper pixel to detect if we've scrolled -->
<div class="sbt-scroll-pixel-helper"></div>
<!-- Main content -->
<div class="col py-0 content-container">
    
    <div class="header-article row sticky-top noprint">
        



<div class="col py-1 d-flex header-article-main">
    <div class="header-article__left">
        
        <label for="__navigation"
  class="headerbtn"
  data-toggle="tooltip"
data-placement="right"
title="Toggle navigation"
>
  

<span class="headerbtn__icon-container">
  <i class="fas fa-bars"></i>
  </span>

</label>

        
    </div>
    <div class="header-article__right">
<button onclick="toggleFullScreen()"
  class="headerbtn"
  data-toggle="tooltip"
data-placement="bottom"
title="Fullscreen mode"
>
  

<span class="headerbtn__icon-container">
  <i class="fas fa-expand"></i>
  </span>

</button>

<div class="menu-dropdown menu-dropdown-download-buttons">
  <button class="headerbtn menu-dropdown__trigger"
      aria-label="Download this page">
      <i class="fas fa-download"></i>
  </button>
  <div class="menu-dropdown__content">
    <ul>
      <li>
        <a href="_sources/readme.md.txt"
   class="headerbtn"
   data-toggle="tooltip"
data-placement="left"
title="Download source file"
>
  

<span class="headerbtn__icon-container">
  <i class="fas fa-file"></i>
  </span>
<span class="headerbtn__text-container">.md</span>
</a>

      </li>
      
      <li>
        
<button onclick="printPdf(this)"
  class="headerbtn"
  data-toggle="tooltip"
data-placement="left"
title="Print to PDF"
>
  

<span class="headerbtn__icon-container">
  <i class="fas fa-file-pdf"></i>
  </span>
<span class="headerbtn__text-container">.pdf</span>
</button>

      </li>
      
    </ul>
  </div>
</div>
<label for="__page-toc"
  class="headerbtn headerbtn-page-toc"
  
>
  

<span class="headerbtn__icon-container">
  <i class="fas fa-list"></i>
  </span>

</label>

    </div>
</div>

<!-- Table of contents -->
<div class="col-md-3 bd-toc show noprint">
    <div class="tocsection onthispage pt-5 pb-3">
        <i class="fas fa-list"></i> Contents
    </div>
    <nav id="bd-toc-nav" aria-label="Page">
        <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#description">
   Description
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#requirements">
   Requirements
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#installation">
   Installation
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#basic-usage">
   Basic usage
  </a>
  <ul class="nav section-nav flex-column">
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#terminology">
     Terminology
    </a>
   </li>
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#importing-data">
     Importing data
    </a>
   </li>
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#usage-notes-for-the-nematicplot-gui">
     Usage notes for the
     <code class="docutils literal notranslate">
      <span class="pre">
       NematicPlot
      </span>
     </code>
     GUI
    </a>
   </li>
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#non-gui-usage">
     Non-GUI usage
    </a>
   </li>
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#computing-other-field-arrays">
     Computing other field arrays
    </a>
   </li>
  </ul>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#license">
   License
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#roadmap">
   Roadmap
  </a>
  <ul class="nav section-nav flex-column">
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#todo">
     TODO:
    </a>
   </li>
  </ul>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#authors">
   Authors
  </a>
 </li>
</ul>

    </nav>
</div>
    </div>
    <div class="article row">
        <div class="col pl-md-3 pl-lg-5 content-container">
            <!-- Table of contents that is only displayed when printing the page -->
            <div id="jb-print-docs-body" class="onlyprint">
                <h1>open-ViewMin</h1>
                <!-- Table of contents -->
                <div id="print-main-content">
                    <div id="jb-print-toc">
                        
                        <div>
                            <h2> Contents </h2>
                        </div>
                        <nav aria-label="Page">
                            <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#description">
   Description
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#requirements">
   Requirements
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#installation">
   Installation
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#basic-usage">
   Basic usage
  </a>
  <ul class="nav section-nav flex-column">
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#terminology">
     Terminology
    </a>
   </li>
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#importing-data">
     Importing data
    </a>
   </li>
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#usage-notes-for-the-nematicplot-gui">
     Usage notes for the
     <code class="docutils literal notranslate">
      <span class="pre">
       NematicPlot
      </span>
     </code>
     GUI
    </a>
   </li>
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#non-gui-usage">
     Non-GUI usage
    </a>
   </li>
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#computing-other-field-arrays">
     Computing other field arrays
    </a>
   </li>
  </ul>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#license">
   License
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#roadmap">
   Roadmap
  </a>
  <ul class="nav section-nav flex-column">
   <li class="toc-h3 nav-item toc-entry">
    <a class="reference internal nav-link" href="#todo">
     TODO:
    </a>
   </li>
  </ul>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#authors">
   Authors
  </a>
 </li>
</ul>

                        </nav>
                    </div>
                </div>
            </div>
            <main id="main-content" role="main">
                
              <div>
                
  <section id="open-viewmin">
<h1>open-ViewMin<a class="headerlink" href="#open-viewmin" title="Permalink to this headline">#</a></h1>
<p>Nematic liquid crystal tensorial data visualization environment</p>
<p><em>Human usin’ openQmin, you can zoom in!</em></p>
 <!-- <iframe src="../../../examples/results/html/many_colloids_demo_t3000.html" title="Demo scene" width="700" height="500" style="border:none;" ></iframe> -->
<section id="description">
<h2>Description<a class="headerlink" href="#description" title="Permalink to this headline">#</a></h2>
<p><em>open-ViewMin</em> is a visualization environment for three-dimensional orientation field datasets. It is primarily designed as a visualization companion to the nematic liquid crystal modeling package <a class="reference external" href="https://github.com/sussmanLab/open-Qmin"><em>open-Qmin</em></a>.</p>
<p>The goal of <em>open-ViewMin</em> is to provide an environment similar to
<a class="reference external" href="https://www.paraview.org/"><em>ParaView</em></a> where 3D visualization is fast (ideally, GPU-accelerated) and reasonably good-looking, but that also</p>
<ol class="arabic simple">
<li><p>has a Python interface with <em>NumPy</em> compatibility so that users can visualize calculation results on the fly, and</p></li>
<li><p>comes pre-loaded with many commonly-used analysis methods for nematic LCs,
such as defect identification and Landau-de Gennes or Frank free energy components.</p></li>
</ol>
<p>To do this, <em>open-ViewMin</em> extends <a class="reference external" href="https://github.com/pyvista/pyvistaqt"><em>PyVistaQt</em></a>, a Python package that uses the <em>Qt</em> application-building system as the backend for <a class="reference external" href="https://docs.pyvista.org/"><em>PyVista</em></a>, which in turn is a Python interface to the <a class="reference external" href="https://vtk.org/"><em>Visualization Toolkit (VTK)</em></a>.</p>
<p>In addition to details specific to nematic liquid crystals, <em>open-ViewMin</em> extends <em>PyVista</em> with <code class="docutils literal notranslate"><span class="pre">FilterFormula</span></code> objects, which apply <em>PyVista</em> filters and automatically update them when a parent mesh has changed.</p>
</section>
<section id="requirements">
<h2>Requirements<a class="headerlink" href="#requirements" title="Permalink to this headline">#</a></h2>
<p>You’ll need a Python 3.7, 3.8, or 3.9 installation. Python 3.9 is recommended as it is used for development of <em>open-ViewMin</em>. This package will <strong>not</strong> work with Python 3.10. Earlier versions than 3.7 haven’t been tested.</p>
</section>
<section id="installation">
<h2>Installation<a class="headerlink" href="#installation" title="Permalink to this headline">#</a></h2>
<ol class="arabic">
<li><p>Download the source code using</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">git</span> <span class="n">clone</span> <span class="n">https</span><span class="p">:</span><span class="o">//</span><span class="n">gitlab</span><span class="o">.</span><span class="n">com</span><span class="o">/</span><span class="n">d</span><span class="o">.</span><span class="n">a</span><span class="o">.</span><span class="n">beller</span><span class="o">/</span><span class="n">openviewmin</span><span class="o">/</span>
<span class="n">cd</span> <span class="n">openviewmin</span>
</pre></div>
</div>
</li>
<li><p>It is recommended to create a virtual environment.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">python3</span> <span class="o">-</span><span class="n">m</span> <span class="n">venv</span> <span class="n">ovm</span><span class="o">-</span><span class="n">env</span>  <span class="c1"># replace &quot;python3&quot; with path to python executable</span>
<span class="n">source</span> <span class="n">ovm</span><span class="o">-</span><span class="n">env</span><span class="o">/</span><span class="nb">bin</span><span class="o">/</span><span class="n">activate</span>
<span class="n">pip</span> <span class="n">install</span> <span class="o">--</span><span class="n">upgrade</span> <span class="n">pip</span>
</pre></div>
</div>
</li>
<li><p>From the <em>openviewmin/</em> directory, install the package as:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">pip</span> <span class="n">install</span> <span class="o">.</span>
</pre></div>
</div>
</li>
<li><p>Finally, to use <em>open_viewmin</em> in a Jupyter notebook, make the <em>ovm-env</em> virtual environment available as a notebook kernel:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">python3</span> <span class="o">-</span><span class="n">m</span> <span class="n">ipykernel</span> <span class="n">install</span> <span class="o">--</span><span class="n">user</span> <span class="o">--</span><span class="n">name</span> <span class="n">ovm</span><span class="o">-</span><span class="n">env</span>
<span class="nb">hash</span> <span class="o">-</span><span class="n">r</span>  <span class="c1"># so &quot;ipython&quot; command uses this Python version in future</span>
</pre></div>
</div>
</li>
</ol>
</section>
<section id="basic-usage">
<h2>Basic usage<a class="headerlink" href="#basic-usage" title="Permalink to this headline">#</a></h2>
<p>A user can open the GUI directly from the command line as <code class="docutils literal notranslate"><span class="pre">./viewmin.py</span></code>.</p>
<p>However, more control is gained by combining the GUI and Python interfaces, so it is recommended to run the GUI in the background of a Python interpreter or Jupyter notebook.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">open_viewmin</span> <span class="k">as</span> <span class="nn">ovm</span>  <span class="c1"># this might take a few minutes the first time it runs </span>
<span class="n">my_plot</span> <span class="o">=</span> <span class="n">ovm</span><span class="o">.</span><span class="n">NematicPlot</span><span class="p">(</span><span class="n">dims</span><span class="o">=</span><span class="p">(</span><span class="mi">10</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="mi">10</span><span class="p">))</span>  <span class="c1"># empty 10x10x10 grid</span>

<span class="c1"># or</span>

<span class="n">my_plot</span> <span class="o">=</span> <span class="n">ovm</span><span class="o">.</span><span class="n">NematicPlot</span><span class="p">(</span><span class="s1">&#39;my_file_x0y0z0.txt&#39;</span><span class="p">)</span>  <span class="c1"># open-Qmin data</span>
</pre></div>
</div>
<p>Treat <code class="docutils literal notranslate"><span class="pre">my_plot</span></code> like a dictionary in terms of accessing its meshes. To create a new mesh with a <code class="docutils literal notranslate"><span class="pre">PyVista</span></code> filter, use <code class="docutils literal notranslate"><span class="pre">add_filter</span></code>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">my_plot</span><span class="p">[</span><span class="s2">&quot;sliced&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">my_plot</span><span class="p">[</span><span class="s2">&quot;fullmesh&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">add_filter</span><span class="p">(</span><span class="s2">&quot;slice&quot;</span><span class="p">,</span> <span class="n">normal</span><span class="o">=</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">))</span>
</pre></div>
</div>
<p>To change an existing mesh, alter the filter’s parameters using <code class="docutils literal notranslate"><span class="pre">update()</span></code>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">my_plot</span><span class="p">[</span><span class="s2">&quot;sliced&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">normal</span><span class="o">=</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">))</span>
</pre></div>
</div>
<p>Change visualization options for the mesh using <code class="docutils literal notranslate"><span class="pre">set()</span></code>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">my_plot</span><span class="p">[</span><span class="s2">&quot;sliced&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="n">color</span><span class="o">=</span><span class="s2">&quot;green&quot;</span><span class="p">)</span>
</pre></div>
</div>
<section id="terminology">
<h3>Terminology<a class="headerlink" href="#terminology" title="Permalink to this headline">#</a></h3>
<ul class="simple">
<li><p>A <code class="docutils literal notranslate"><span class="pre">mesh</span></code> is the set of coordinates along with data defined on them.</p></li>
<li><p>A <em>PyVista</em> <code class="docutils literal notranslate"><span class="pre">filter</span></code> maps a parent <code class="docutils literal notranslate"><span class="pre">mesh</span></code> to a child <code class="docutils literal notranslate"><span class="pre">mesh</span></code>.</p></li>
<li><p>An <code class="docutils literal notranslate"><span class="pre">actor</span></code> is an object visualizing a mesh in the plot, and is created by calling <code class="docutils literal notranslate"><span class="pre">pyvista.Plotter.add_mesh()</span></code> with the <code class="docutils literal notranslate"><span class="pre">mesh</span></code> as the first argument.</p></li>
<li><p>When a <code class="docutils literal notranslate"><span class="pre">mesh</span></code> is visualized as an <code class="docutils literal notranslate"><span class="pre">actor</span></code>, we give the same name to the <code class="docutils literal notranslate"><span class="pre">mesh</span></code> and the <code class="docutils literal notranslate"><span class="pre">actor</span></code>.</p></li>
<li><p>If the <code class="docutils literal notranslate"><span class="pre">mesh</span></code> will have no child <code class="docutils literal notranslate"><span class="pre">mesh</span></code> of its own (e.g. for the <code class="docutils literal notranslate"><span class="pre">glyph</span></code> filter), then we will often speak of the <code class="docutils literal notranslate"><span class="pre">filter</span></code> as mapping the parent <code class="docutils literal notranslate"><span class="pre">mesh</span></code> directly to the child mesh’s <code class="docutils literal notranslate"><span class="pre">actor</span></code>.</p></li>
</ul>
</section>
<section id="importing-data">
<h3>Importing data<a class="headerlink" href="#importing-data" title="Permalink to this headline">#</a></h3>
<p>You can import files through the <em>File -&gt; Open files(s)…</em> menu option within the GUI, or by providing the file paths as arguments when calling <em>open-ViewMin</em> from the command line:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>./viewmin.py file1
# or
./viewmin.py file1 file2 file3...
</pre></div>
</div>
<p>or from a Python interpreter or Jupyter notebook:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>import open_viewmin as ovm
my_plot = ovm.NematicPlot(file1)
# or
my_plot = ovm.NematicPlot([file1, file2, file3, ...])
</pre></div>
</div>
<p>Files from the same MPI run are assumed to be labeled as “<em>run_name_x#y#z#.txt</em>” (with the *#*s replaced by some integers). All such files from the same run will be combined into a single file “<em>run_name.txt</em>”.</p>
<p>For importing files from legacy-<em>Qmin</em>/<em>nematicvXX</em>, you need to provide the “Qtensor… .dat” file or files, and make sure the corresponding “Qmatrix… .dat” file is in the same folder.</p>
</section>
<section id="usage-notes-for-the-nematicplot-gui">
<h3>Usage notes for the <code class="docutils literal notranslate"><span class="pre">NematicPlot</span></code> GUI<a class="headerlink" href="#usage-notes-for-the-nematicplot-gui" title="Permalink to this headline">#</a></h3>
<p>Once you’ve imported at least one file, <em>open-ViewMin</em> automatically creates:</p>
<ol class="arabic simple">
<li><p>a view of the director field along a slice “widget” that you can move using the mouse,</p></li>
<li><p>surface(s) for the boundary(ies),</p></li>
<li><p>isosurface of (uniaxial) nematic order to visualize defects.</p></li>
</ol>
<p>Controls for these visualization elements (“actors”) will be on the left. For each actor, these controls include a visibility toggle checkbox and a menu of customization options.</p>
<p>You can add other visualizations of computed fields from the “Add” menu.</p>
<p>If you import more than one file, <em>open-ViewMin</em> will attempt to put them in order of timestamp inferred from the filenames. You can then move through the sequence of timesteps using the buttons at the top of the left toolbar area.</p>
</section>
<section id="non-gui-usage">
<h3>Non-GUI usage<a class="headerlink" href="#non-gui-usage" title="Permalink to this headline">#</a></h3>
<p>If you prefer that the GUI not open, such as if you’re generating snapshots from batch runs, you can pass <code class="docutils literal notranslate"><span class="pre">off_screen=True</span></code> to <code class="docutils literal notranslate"><span class="pre">NematicPlot</span></code>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">my_plot</span> <span class="o">=</span> <span class="n">ovm</span><span class="o">.</span><span class="n">NematicPlot</span><span class="p">(</span><span class="n">file1</span><span class="p">,</span> <span class="n">off_screen</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</pre></div>
</div>
<p>Then, other options to visualize the results include:</p>
<ul class="simple">
<li><p>save a screenshot: <code class="docutils literal notranslate"><span class="pre">my_plot.screenshot('my_image.png')</span></code></p></li>
<li><p>render interactively in Jupyter notebook using <em>pythreejs</em> backend: <code class="docutils literal notranslate"><span class="pre">my_plot.to_pythreejs()</span></code></p></li>
<li><p>render interactively in Jupyter notebook using another backend, such as *panel”: <code class="docutils literal notranslate"><span class="pre">my_plot.extract_actors(jupyter_backend='panel').show()</span></code></p></li>
</ul>
</section>
<section id="computing-other-field-arrays">
<h3>Computing other field arrays<a class="headerlink" href="#computing-other-field-arrays" title="Permalink to this headline">#</a></h3>
<p>You can use Python+<em>NumPy</em> to compute or import field arrays other than the ones provided. This is best done in a Python interpreter or Jupyter notebook, after calling <code class="docutils literal notranslate"><span class="pre">my_plot</span> <span class="pre">=</span> <span class="pre">open_viewmin.NematicPlot()</span></code> from there. The plotter runs in the background, so you can execute Python commands without closing the plot.</p>
<p>You can view a list of the existing arrays using</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>my_plot[&#39;fullmesh&#39;].array_names
</pre></div>
</div>
<p>You can add an array to a mesh by treating it like a Python dictionary and assigning a “key” to a <em>NumPy</em> array. This can be derived from existing arrays, e.g.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">mesh</span> <span class="o">=</span> <span class="n">my_plot</span><span class="p">[</span><span class="s1">&#39;fullmesh&#39;</span><span class="p">]</span>
<span class="n">mesh</span><span class="p">[</span><span class="s2">&quot;splay_plus_twist&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">mesh</span><span class="p">[</span><span class="s2">&quot;LdG_K1&quot;</span><span class="p">]</span> <span class="o">+</span> <span class="n">mesh</span><span class="p">[</span><span class="s2">&quot;LdG_K2&quot;</span><span class="p">]</span>
</pre></div>
</div>
<p>or created by any other means, as long as the length of the array’s first axis equals the number of points in the mesh, e.g.</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>import numpy as np
my_plot[&#39;fullmesh&#39;][&quot;my_silly_array&quot;] = (
  np.random.random(my_plot[&#39;fullmesh&#39;].mesh.n_points)
)
</pre></div>
</div>
<p>If the new array is a “scalar field” i.e. it has one value for each point in the mesh, then it will automatically appear in the appropriate submenus in the “Add” menu.</p>
<p>Important: In order for the new array to be inherited by the other meshes descended from “fullmesh”, you should press the Refresh button (circle of two blue arrows) in the top menu area.</p>
</section>
</section>
<section id="license">
<h2>License<a class="headerlink" href="#license" title="Permalink to this headline">#</a></h2>
<p><em>open-ViewMin</em> is released open-source under the <a class="reference internal" href="LICENSE.html"><span class="doc std std-doc">MIT license</span></a>. However, <em>open-ViewMin</em> depends on <em>PyVistaQt</em>, which depends on Qt bindings to Python that have their own licenses. See https://qtdocs.pyvista.org/ under “License”.</p>
</section>
<section id="roadmap">
<h2>Roadmap<a class="headerlink" href="#roadmap" title="Permalink to this headline">#</a></h2>
<section id="todo">
<h3>TODO:<a class="headerlink" href="#todo" title="Permalink to this headline">#</a></h3>
<ul class="simple">
<li><p>hedgehog charge of loop defects</p></li>
</ul>
</section>
</section>
<section id="authors">
<h2>Authors<a class="headerlink" href="#authors" title="Permalink to this headline">#</a></h2>
<p>Created by Daniel Beller, 2021-2022.</p>
<p>Jones matrix calculations written by Sophie Ettinger, Yvonne Zagzag, and Daniel Beller.</p>
</section>
</section>


              </div>
              
            </main>
            <footer class="footer-article noprint">
                
    <!-- Previous / next buttons -->
<div class='prev-next-area'>
    <a class='left-prev' id="prev-link" href="index.html" title="previous page">
        <i class="fas fa-angle-left"></i>
        <div class="prev-next-info">
            <p class="prev-next-subtitle">previous</p>
            <p class="prev-next-title">open-ViewMin documentation</p>
        </div>
    </a>
    <a class='right-next' id="next-link" href="filters-tree.html" title="next page">
    <div class="prev-next-info">
        <p class="prev-next-subtitle">next</p>
        <p class="prev-next-title">The Filters Tree</p>
    </div>
    <i class="fas fa-angle-right"></i>
    </a>
</div>
            </footer>
        </div>
    </div>
    <div class="footer-content row">
        <footer class="col footer"><p>
  
    By Daniel Beller<br/>
  
      &copy; Copyright 2022, Daniel Beller.<br/>
</p>
        </footer>
    </div>
    
</div>


      </div>
    </div>
  
  <!-- Scripts loaded after <body> so the DOM is not blocked -->
  <script src="_static/scripts/pydata-sphinx-theme.js?digest=1999514e3f237ded88cf"></script>


  </body>
</html>